"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setFormErrors = void 0;
var deepCopy_1 = require("@cnamts/vue-dot/src/helpers/deepCopy");
/** Set error-messages prop on the fields in error */
function setFormErrors(formErrors, form) {
    var newForm = (0, deepCopy_1.deepCopy)(form);
    for (var _i = 0, _a = Object.entries(newForm); _i < _a.length; _i++) {
        var sectionName = _a[_i][0];
        for (var _b = 0, _c = Object.entries(formErrors); _b < _c.length; _b++) {
            var _d = _c[_b], fieldName = _d[0], errors = _d[1];
            var field = newForm[sectionName].questions[fieldName];
            if (!field || !errors) {
                continue;
            }
            var fieldOptions = field.fieldOptions || {};
            if (typeof errors === 'string' || Array.isArray(errors)) {
                fieldOptions.errorMessages = errors;
            }
            else if (typeof errors === 'object') {
                for (var _e = 0, _f = Object.entries(errors); _e < _f.length; _e++) {
                    var _g = _f[_e], subFieldName = _g[0], subErrors = _g[1];
                    if (subFieldName === 'value' || subFieldName === 'other') {
                        if (!fieldOptions.errorMessages) {
                            fieldOptions.errorMessages = {};
                        }
                        fieldOptions.errorMessages[subFieldName] = subErrors;
                        continue;
                    }
                    var subFieldOptions = fieldOptions[subFieldName] || {};
                    subFieldOptions.errorMessages = subErrors;
                    fieldOptions[subFieldName] = subFieldOptions;
                }
            }
            else {
                continue;
            }
            newForm[sectionName].questions[fieldName].fieldOptions = fieldOptions;
        }
    }
    return newForm;
}
exports.setFormErrors = setFormErrors;
